<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Linear Algebra Operations</TITLE>
<link href="suifmath_35.html" rel=Next>
<link href="suifmath_33.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_33.html">previous</A>, <A HREF="suifmath_35.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC38" HREF="suifmath_toc.html#TOC38">Linear Algebra Operations</A></H3>

<P>
<A NAME="IDX544"></A>
<A NAME="IDX545"></A>
<A NAME="IDX546"></A>
The <CODE>matrix</CODE> class stores both the elements of the matrix and the
LU decomposition.  A single <CODE>fract_matrix</CODE> is used to store the
lower-triangular (L) and upper-triangular (U) matrices.  The class also
keeps track of which columns are pivot columns, and which columns where
permuted to compute the LU decomposition.  Whenever any of the elements
in the matrix are changed, the LU decomposition of the matrix is marked
invalid.  Whenever the LU decomposition is needed, it is recalculated if
currently invalid.  The <CODE>is_factored</CODE> method checks if the LU
decomposition is up-to-date.  The <CODE>factor</CODE> method is called to
calculate the LU decomposition; it will only do the calculation if the
current decomposition is not valid.

</P>
<P>
<A NAME="IDX547"></A>
<A NAME="IDX548"></A>
<A NAME="IDX549"></A>
<A NAME="IDX550"></A>
<A NAME="IDX551"></A>
<A NAME="IDX552"></A>
<A NAME="IDX553"></A>
<A NAME="IDX554"></A>
The <CODE>is_pivot</CODE> method returns <CODE>TRUE</CODE> if its integer argument
is a pivot column in the LU decomposition.  The <CODE>rank</CODE> method
returns the integer rank of the matrix.  Also, the methods
<CODE>full_row_rank</CODE> and <CODE>full_column_rank</CODE> check if the rank of
the matrix is equal to the number of row or columns, respectively.

</P>
<P>
<A NAME="IDX555"></A>
The method <CODE>inverse</CODE> returns the inverse of the current matrix.
(the matrix must be non-singular and square).

</P>
<P>
<A NAME="IDX556"></A>
<A NAME="IDX557"></A>
<A NAME="IDX558"></A>
<A NAME="IDX559"></A>
<A NAME="IDX560"></A>
<A NAME="IDX561"></A>
The method <CODE>range</CODE> returns the <CODE>vector_space</CODE> (see section <A HREF="suifmath_27.html#SEC31">Vector Spaces for Linear Algebra</A>) that corresponds to the column space, or
range, of the matrix.  The column space of a matrix contains all the
points that are combinations of its columns (i.e. all points <CODE>b</CODE>
such that <CODE>Ax = b</CODE>).  The method <CODE>kernel</CODE> returns a
<CODE>vector_space</CODE> representing the null-space, or kernel of the
matrix.  The kernel of a matrix <CODE>A</CODE> is the set of all vectors
<CODE>x</CODE> such that <CODE>Ax = 0</CODE>.  If <CODE>A</CODE> is an <CODE>m</CODE> by
<CODE>n</CODE> matrix with rank <CODE>r</CODE>, then the kernel has dimension
<CODE>n - r</CODE>.  See section <A HREF="suifmath_27.html#SEC31">Vector Spaces for Linear Algebra</A>.
For example, given the following matrix:

</P>

<PRE>
[ 1 4 0 ]
[ 0 3 0 ] 
</PRE>

<P>
The kernel is:

</P>

<PRE>
{(0, 0, 1)}
</PRE>

<P>
<A NAME="IDX562"></A>
<A NAME="IDX563"></A>
For the matrix <CODE>A</CODE>, the method <CODE>particular_solution</CODE> returns
the particular solution to the equation <CODE>Ax = b</CODE>.  If a single
solution exists to this equation, then the particular solution is simply
the one solution.  If infinite solutions exist, then the particular
solution is the solution with all free variables set to 0.  In general,
all possible solutions to the equation can be represented as the sum of
the particular solution and a solution to <CODE>Ax = 0</CODE>.  The method
takes as arguments the <CODE>fract_vector</CODE> <CODE>b</CODE> and a boolean valid
flag.  If a solution was found, the flag is set to <CODE>TRUE</CODE> and the
<CODE>fract_vector</CODE> <CODE>x</CODE> is returned.  If no solution exists, then
the flag is set to <CODE>FALSE</CODE>.  For example given the equation:

</P>

<PRE>
[ 4 3 8 2 ]      [ 1 ]                          
[ 0 0 3 1 ] x =  [ 4 ]
[ 0 0 0 0 ]      [ 0 ] 
</PRE>

<P>
The particular solution is:

</P>

<PRE>
[ -29/12 ]                          
[    0   ]
[   4/3  ] 
[    0   ] 
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_33.html">previous</A>, <A HREF="suifmath_35.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
